#ifndef GGAFDXCORE_GGAFDXBOARDSETACTORD_H_
#define GGAFDXCORE_GGAFDXBOARDSETACTORD_H_
#include "GgafDxCommonHeader.h"
#include "jp/ggaf/dxcore/actor/GgafDxFigureActor.h"

namespace GgafDxCore {

/**
 * Wϊς݂̃XvCgAN^[(ʕ\p) .
 * GgafDxTransformedActor pA|SɃeNX`\t<BR>
 * GgafDxBoardActorɁAꃂf͈ꊇ`s悤ɍœKAN^[B<BR>
 * ]@\ȂAgk@\ȂB<BR>
 * P\̂ߍB\AwiɎgpB<BR>
 * @version 1.00
 * @since 2009/07/21
 * @author Masatoshi Tsuge
 */
class GgafDxBoardSetActor : public GgafDxFigureActor {
private:
    /**
     * gps̂߁Aprivateoverride
     * @return
     */
    int isOutOfView() override {
        throwGgafCriticalException("gpsłB");
        return 0;
    }

    /**
     * gps̂߁Aprivateoverride
     * @return
     */
    bool isOutOfSpacetime() const override {
        throwGgafCriticalException("gpsłB");
        return false;
    }

    /**
     * gps̂߁Aprivateoverride
     * @return
     */
    GgafCore::GgafGroupHead* addSubGroupAsFk(actorkind prm_kind,
                                             GgafDxGeometricActor* prm_pGeoActor,
                                             int prm_x_init_local,
                                             int prm_y_init_local,
                                             int prm_z_init_local,
                                             int prm_rx_init_local,
                                             int prm_ry_init_local,
                                             int prm_rz_init_local) override {
        throwGgafCriticalException("gpsłB");
        return nullptr;
    }

    /**
     * gps̂߁Aprivateoverride
     * @return
     */
    GgafCore::GgafGroupHead* addSubGroupAsFk(GgafDxGeometricActor* prm_pGeoActor,
                                             int prm_x_init_local,
                                             int prm_y_init_local,
                                             int prm_z_init_local,
                                             int prm_rx_init_local,
                                             int prm_ry_init_local,
                                             int prm_rz_init_local) override {
        throwGgafCriticalException("gpsłB");
        return nullptr;
    }

    void setFaceAngAs(const GgafDxGeoElem* prm_pActor) override {
        throwGgafCriticalException("gpsłB");
    }
    void setFaceAngAs(const GgafDxGeometricActor* prm_pActor) override {
        throwGgafCriticalException("gpsłB");
    }
    void setScale(scale S) override {
        throwGgafCriticalException("gpsłB");
    }
    void setScale(scale SX, scale SY) override {
        throwGgafCriticalException("gpsłB");
    }
    void setScale(scale SX, scale SY, scale SZ) override {
        throwGgafCriticalException("gpsłB");
    }
    void setScaleR(float prm_rate) override {
        throwGgafCriticalException("gpsłB");
    }
    void setScaleR(float prm_x_rate, float prm_y_rate, float prm_z_rate) override {
        throwGgafCriticalException("gpsłB");
    }
    void setScaleR(float prm_x_rate, float prm_y_rate) override {
        throwGgafCriticalException("gpsłB");
    }
    void addScale(scale dS) override {
        throwGgafCriticalException("gpsłB");
    }
    void addScaleX(scale dsx) override {
        throwGgafCriticalException("gpsłB");
    }
    void addScaleY(scale dsy) override {
        throwGgafCriticalException("gpsłB");
    }
    void addScaleZ(scale dsz) override {
        throwGgafCriticalException("gpsłB");
    }

public:
    /** [r]fIuWFNgւ̃|C^ */
    GgafDxBoardSetModel* const _pBoardSetModel;
    /** [r]GtFNg */
    GgafDxBoardSetEffect* const _pBoardSetEffect;
    /** [r]UVtbp[(ppAj) */
    GgafDxUvFlipper* const _pUvFlipper;
    /** [r](px) */
    pixcoord _width_px;
    /** [r](px) */
    pixcoord _height_px;
    /** [r](px)̔ */
    pixcoord _harf_width_px;
    /** [r](px)̔ */
    pixcoord _harf_height_px;
    GgafDxAlign _align;
    GgafDxValign _valign;

public:
    GgafDxBoardSetActor(const char* prm_name,
                        const char* prm_model_id,
                        const char* prm_effect_id,
                        const char* prm_technique );

    virtual void processDraw() override;


    virtual void processSettlementBehavior() override {
    }

    virtual ~GgafDxBoardSetActor(); //fXgN^

    virtual void positionAs(const GgafDxGeometricActor* prm_pActor) override;

    virtual void positionAs(const GgafDxGeoElem* prm_pGeoElem) override;

    virtual void setAlign(GgafDxAlign prm_align, GgafDxValign prm_valign);
    virtual void setAlign(GgafDxAlign prm_align);
    virtual void setValign(GgafDxValign prm_valign);

    inline GgafDxUvFlipper* getUvFlipper() {
        return _pUvFlipper;
    }
    float getModelWidth();
    float getModelHeight();
};

}
#endif /*GGAFDXCORE_GGAFDXBOARDSETACTORD_H_*/
