#ifndef GGAFDXCORE_GGAFDXMASSPOINTSPRITEMODEL_H_
#define GGAFDXCORE_GGAFDXMASSPOINTSPRITEMODEL_H_
#include "GgafDxCommonHeader.h"
#include "jp/ggaf/dxcore/model/GgafDxMassModel.h"

namespace GgafDxCore {


/**
 * @version 1.00
 * @since 2016/05/16
 * @author Masatoshi Tsuge
 */
class GgafDxMassPointSpriteModel : public GgafDxMassModel {
    friend class GgafDxModelManager;

public:
//    struct VERTEX_model : public GgafDxModel::VERTEX_3D_BASE {
//        D3DCOLOR color;   // _̐FiIuWFNg̃}eAJ[ƂĎgp\j
//        float tu, tv;     // eNX`W
//    };

    struct VERTEX_model {
        float x, y, z;    // _W
        float psize;      // |CgTCY
        DWORD color;      // _̐F
        float tu, tv;     // eNX`W
    };
    VERTEX_model* _paVtxBuffer_data_model;
//    WORD* _paIndexBuffer_data;

    /** IuWFNĝPӂ̃TCY(px) */
    float _square_size_px;
    /** eNX`̂Pӂ̒(px) */
    float _texture_size_px;
    /** eNX`(PŕBQłSp^[ARłXp^[) */
    int _texture_split_rowcol;
public:
    /**
     * RXgN^<BR>
     * @param prm_model_name XvCg`̎ʖB".x"ǉƒ`Xt@CɂȂB
     */
    GgafDxMassPointSpriteModel(const char* prm_model_name);

    static void createVertexModel(void* prm, GgafDxMassModel::VertexModelInfo* out_info);

    virtual HRESULT draw(GgafDxFigureActor* prm_pActor_target, int prm_draw_set_num = 1, void* prm_pPrm = nullptr) override;

    virtual void restore() override;

    /**
     * fXgN^<BR>
     */
    virtual ~GgafDxMassPointSpriteModel(); //fXgN^
};

}
#endif /*GGAFDXCORE_GGAFDXMASSPOINTSPRITEMODEL_H_*/
