#include "Shot003.h"

#include "jp/ggaf/dxcore/actor/supporter/GgafDxSeTransmitterForActor.h"
#include "jp/ggaf/dxcore/actor/supporter/GgafDxKuroko.h"
#include "jp/gecchi/VioletVreath/util/MyStgUtil.h"
#include "jp/ggaf/lib/util/CollisionChecker3D.h"

using namespace GgafCore;
using namespace GgafDxCore;
using namespace GgafLib;
using namespace VioletVreath;

Shot003::Shot003(const char* prm_name) :
        DefaultMassMeshActor(prm_name, "laser_single", STATUS(Shot003)) {
    _class_name = "Shot003";
}

void Shot003::initialize() {
    setHitAble(false);
    _sx = _sy = _sz = R_SC(50);
    setAlpha(0.99); //ɂ邱Ƃŗʃ_O
    setZEnableDraw(true);   //`掞AZobt@l͍l
    setZWriteEnable(false); //gZobt@݂Ȃ
    effectBlendOne();       //Z
    CollisionChecker3D* pChecker = getCollisionChecker();
    pChecker->createCollisionArea(1);
    pChecker->setColliAABox_Cube(0, PX_C(16));
}

void Shot003::onActive() {
    setHitAble(true);
    getKuroko()->setMvVelo(20000);

}

void Shot003::processBehavior() {
    //ZN|Cg
    //Wɔf
    GgafDxKuroko* const pKuroko = getKuroko();
    pKuroko->behave();
}

void Shot003::processJudgement() {
    if (isOutOfSpacetime()) {
        sayonara();
    }
}

void Shot003::onHit(const GgafActor* prm_pOtherActor) {
//    GgafDxGeometricActor* pOther = (GgafDxGeometricActor*)prm_pOtherActor;
//    //EEERRɃqbgꂽGtFNg
//    if (MyStgUtil::calcEnemyStamina(this, pOther) <= 0) {
//        //j󂳂ꂽꍇ
//        //EEERRɔj󂳂ꂽGtFNg
//        EffectExplosion003* pExplo003 = (EffectExplosion003*)P_COMMON_SCENE->pDepo_EffectExplosion003_->dispatch();
//        playSe3D1();
//        if (pExplo003) {
//            pExplo003->positionAs(this);
//        }
//        sayonara();
//    }
}

Shot003::~Shot003() {
}
