#ifndef FORMATIONDELHEID_H_
#define FORMATIONDELHEID_H_
#include "VioletVreath.h"
#include "jp/ggaf/lib/actor/DepositoryFormation.h"

#include "jp/ggaf/dxcore/util/GgafDxGeoElem.h"

namespace VioletVreath {

/**
 * G@fwChptH[[V .
 * @version 1.00
 * @since 2013/04/15
 * @author Masatoshi Tsuge
 */
class FormationDelheid : public GgafLib::DepositoryFormation {

public:
    enum {
        PROG_INIT  ,
        PROG_ENTRY ,
        PROG_FROMATION_MOVE1,
        PROG_FROMATION_MOVE2,
        PROG_FROMATION_MOVE3,
        PROG_FROMATION_MOVE4,
        PROG_FROMATION_MOVE5,
        PROG_LEAVE ,
        PROG_BANPEI,
    };


    /** fwCh؂ꌳDepositoryւ̐ڑ */
    DepositoryConnection* pConn_pDelheidDepo_;
    /** fwCh̔˒e̎؂ꌳDepositoryւ̐ڑ */
    DepositoryConnection* pConn_pShotDepo_;
    /** n_EI_̍WvẐ߂̃_~[ */
    EnemyDelheid* pDummy_;

    /** n_̃ATi */
    EnemyAlisana* pAlisana_start;
    /** I_̃ATi */
    EnemyAlisana* pAlisana_goal;
    /** [r]ݒuWƌ */
    GgafDxCore::GgafDxGeoElem geoLocate_;

    /** ґ(RANKϓ) */
    int RV_Num_;
    /** ґo[̏oԊut[(RANKϓ) */
    frame RV_LaunchInterval;
    /** ґo[̏ړx(RANKϓ) */
    velo RV_MvVelo_;

public:
    /**
     * RXgN^ .
     * @param prm_name
     */
    FormationDelheid(const char* prm_name) ;

    void updateRankParameter();

    virtual void initialize() override;

    virtual void onActive() override;

    virtual void onCallUpDelheid(EnemyDelheid* pEnemyDelheid) = 0;

    /**
     * ґSĎ@̍Uşrłꂽꍇ̏ .
     * @param prm_pActor_last_destroyed  Ōɔj󂳂ꂽAN^[
     */
    virtual void onDestroyAll(GgafCore::GgafActor* prm_pActor_last_destroyed) override;

    virtual void processBehavior() override;
    /**
     * XvC擾B
     * ʂŎĉB
     * @return
     */
    virtual GgafLib::SplineManufacture* getSplManuf() = 0;

    virtual void onSayonaraAll() override;


    static void order1(GgafCore::GgafActor* prm_pDelheid, void* prm1, void* prm2);

    static void order2(GgafCore::GgafActor* prm_pDelheid, void* prm1, void* prm2);

    static void order3(GgafCore::GgafActor* prm_pDelheid, void* prm1, void* prm2);

    /**
     * ݒuWƌZbg .
     */
    void position(coord x, coord y, coord z,
                  angle rx, angle rz, angle ry) {
        geoLocate_.x = x;
        geoLocate_.y = y;
        geoLocate_.z = z;
        geoLocate_.rx = rx;
        geoLocate_.rz = rz;
        geoLocate_.ry = ry;
    }

    virtual ~FormationDelheid();
};

}
#endif /*FORMATIONDELHEID_H_*/
