#ifndef GGAFDXCOMMONHEADER_H_
#define GGAFDXCOMMONHEADER_H_
#include "GgafCommonHeader.h"

#define DIRECTINPUT_VERSION 0x0800

#ifndef DECLSPEC_DEPRECATED
#if (_MSC_VER >= 1300) && !defined(MIDL_PASS)
#define DECLSPEC_DEPRECATED   __declspec(deprecated)
#define DEPRECATE_SUPPORTED
#else
#define DECLSPEC_DEPRECATED
#undef  DEPRECATE_SUPPORTED
#endif
#endif
//http://www.ogre3d.org/forums/viewtopic.php?f=2&t=45140
//ӖYꂽAQƂ

#define GGAF_MAX_VOLUME (1000)
#define GGAF_MIN_VOLUME (0)


/** ]@萔A߂ɉ] */
#define TURN_CLOSE_TO 0
/** ]@萔Aɉ] */
#define TURN_ANTICLOSE_TO 2
/** ]@萔Avɉ] */
#define TURN_CLOCKWISE (-1)
/** ]@萔Avɉ] */
#define TURN_COUNTERCLOCKWISE 1
/** ]@萔Aǂ炩̉]ỉ]łj */
#define TURN_BOTH 0


//vYp(ʒu)萔
#define POS_PRISM_XY_nn   (0x11) //0b 00010001
#define POS_PRISM_XY_np   (0x12) //0b 00010010
#define POS_PRISM_XY_pn   (0x14) //0b 00010100
#define POS_PRISM_XY_pp   (0x18) //0b 00011000
#define POS_PRISM_YZ_nn   (0x21) //0b 00100001
#define POS_PRISM_YZ_np   (0x22) //0b 00100010
#define POS_PRISM_YZ_pn   (0x24) //0b 00100100
#define POS_PRISM_YZ_pp   (0x28) //0b 00101000
#define POS_PRISM_ZX_nn   (0x41) //0b 01000001
#define POS_PRISM_ZX_np   (0x42) //0b 01000010
#define POS_PRISM_ZX_pn   (0x44) //0b 01000100
#define POS_PRISM_ZX_pp   (0x48) //0b 01001000

//vÝAǂ̖ʂăXCXꂽ
/** XYʂɐɃXCX`ł */
#define POS_PRISM_XY      (0x10) //0b 00010000
/** YZʂɐɃXCX`ł */
#define POS_PRISM_YZ      (0x20) //0b 00100000
/** ZXʂɐɃXCX`ł */
#define POS_PRISM_ZX      (0x40) //0b 01000000

//XCXŏovY(Sʂ)̈ʒuA
//pOp`̒pꏊɒڂA
//ʍW̏ی(W̐)ŎB
//n = negative(), p = positive()
/** pꏊ , (, )ł */
#define POS_PRISM_nn      (0x1)  //0b 00000001
/** pꏊ , (, )ł */
#define POS_PRISM_np      (0x2)  //0b 00000010
/** pꏊ , (, )ł */
#define POS_PRISM_pn      (0x4)  //0b 00000100
/** pꏊ , (, )ł */
#define POS_PRISM_pp      (0x8)  //0b 00001000



//p̒_̈ʒulK|W
//                  xyz
#define POS_PYRAMID_nnn   (0x80) //0b  10000000
#define POS_PYRAMID_nnp   (0x81) //0b  10000001
#define POS_PYRAMID_npn   (0x82) //0b  10000010
#define POS_PYRAMID_npp   (0x83) //0b  10000011
#define POS_PYRAMID_pnn   (0x84) //0b  10000100
#define POS_PYRAMID_pnp   (0x85) //0b  10000101
#define POS_PYRAMID_ppn   (0x86) //0b  10000110
#define POS_PYRAMID_ppp   (0x87) //0b  10000111

#define POS_PYRAMID_p__   (0x4)  //0b  00000100
#define POS_PYRAMID__p_   (0x2)  //0b  00000010
#define POS_PYRAMID___p   (0x1)  //0b  00000001

//DirectX3DԂ̍WPʂPɑ΂Ă̌_t߂̉pxiʍ(px)ȂǂAPX_UNITŊ3DԂ̍WPʂPɂȂj
#define PX_UNIT (10)
//_t߂̉ʏ̂Ppxɑ΂ĂPGł̍WPʂ̔䗦iPGł̍WPʂ LEN_UNITŊ3DԂpxɂȂj
#define LEN_UNIT (1000)
#define PI  (3.14159265358979323846)
#define PI2 (6.28318530717958647692)

//VF[_[2.0̌Ẽ[t^[Qbg6
#define MAX_MORPH_TARGET 6

/** AvP[VWP (ڈF 1 coord  =  0.001 pixcoord  =  0.00001 dxcoord  ) */
typedef int coord;
/** AvP[VWPʌn̑x */
typedef int velo;
/**  AvP[VWPʌn̉x */
typedef int acce;
/**  AvP[VWPʌn̖x(TODO:ݖgp) */
typedef int jerk;

/** sNZWP (ڈF 1 pixcoord  =  1000 coord   =  0.1 dxcoord ) */
typedef int pixcoord;
/** DirectXWP  (ڈF 1 dxcoord   =  10 pixcoord  =  10000 coord ) */
typedef float dxcoord;

/** AvP[VXP[P (ڈF 1 scale  =  0.001 {) */
typedef int scale;
typedef int scalevelo;
typedef int scaleacce;
/** AvP[VpxP (ڈF 1 angle  =  0.001 x) */
typedef int angle;
/** AvP[VpxPʌn̊px */
typedef int angvelo;
/** AvP[VpxPʌn̊px */
typedef int angacce;
/** AvP[VpxPʌn̊px */
typedef int angjerk;

/** AvP[V̊pxxP(t[[Np) */
typedef int s_ang;

/** ^(AXIS_X / AXIS_Y / AXIS_Z) */
enum {
    AXIS_X = 0,
    AXIS_Y,
    AXIS_Z
};

typedef int axis;
typedef int dir26;
typedef int dir8;
#define MAX_SCALE (2147483647)


/** Av̍W  DirectXW ϊ */
#define C_DX(X)  ( (dxcoord)((X) * (1.0 / (LEN_UNIT * PX_UNIT))) )
/** DirectXW  Av̍W ϊ */
#define DX_C(X)  ( (coord)((X) * (LEN_UNIT * PX_UNIT)) )
/** DirectXW  sNZW(Jʒu̎) ϊ */
#define DX_PX(X) ( (pixcoord)((X) * PX_UNIT) )
/** sNZW(Jʒu̎) DirectXW ϊ */
#define PX_DX(X) ( (dxcoord)((X) * (1.0 / PX_UNIT)) )
/** Av̍W  sNZW(Jʒu̎) ϊ */
#define C_PX(X)  ( (pixcoord)((X) * (1.0 / LEN_UNIT)) )
/** sNZW(Jʒu̎)  Av̍W ϊ */
#define PX_C(X)  ( (coord)((X) * LEN_UNIT) )

/** AṽAOlx@px ϊ */
#define ANG_D(X) ((int)((X) * 0.001))
/** x@pxAṽAOl ϊ */
#define D_ANG(X) ((angle)((X) * 1000))
///** AṽAOlWA ϊ */
#define ANG_RAD(X) (GgafDxCore::GgafDxUtil::RAD[(X) / SANG_RATE])
/** AṽAOl ϊ */
#define ANG_SIN(X) (GgafDxCore::GgafDxUtil::SIN[(int)((X) * (1.0 / SANG_RATE))])
/** AṽAOl] ϊ */
#define ANG_COS(X) (GgafDxCore::GgafDxUtil::COS[(int)((X) * (1.0 / SANG_RATE))])
/** AṽXP[l  g嗦 ϊ */
#define SC_R(X) ( (float)((X) * (1.0 / LEN_UNIT)) )
/** g嗦  AṽXP[l ϊ */
#define R_SC(X) ( (scale)((X) * LEN_UNIT) )



/** x@ 0 xɑΉAṽAOl萔 */
#define D0ANG   (0)
/** x@ 360 xɑΉAṽAOl萔 */
#define D360ANG (360000)
/** x@ 45 xɑΉAṽAOl萔 */
#define D45ANG  (45000)
/** x@ 90 xɑΉAṽAOl萔 */
#define D90ANG  (90000)
/** x@ 135 xɑΉAṽAOl萔 */
#define D135ANG (135000)
/** x@ 180 xɑΉAṽAOl萔 */
#define D180ANG (180000)
/** x@ 255 xɑΉAṽAOl萔 */
#define D255ANG (225000)
/** x@ 270 xɑΉAṽAOl萔 */
#define D270ANG (270000)
/** x@ 315 xɑΉAṽAOl萔 */
#define D315ANG (315000)
/** WÃ ɑΉAṽAOl萔 */
#define PI_Ang (180000)

#define D0SANG   (0)
#define D360SANG (3600)
#define D45SANG  (450)
#define D90SANG  (900)
#define D135SANG (1350)
#define D180SANG (1800)
#define D225SANG (2250)
#define D270SANG (2700)
#define D315SANG (3150)
/** xpxP  AvP[VpxP ւ̔{ */
#define SANG_RATE (100)


enum GgafDxUvFlippingMethod {
    FLIP_ORDER_LOOP,
    FLIP_REVERSE_LOOP,
    FLIP_OSCILLATE_LOOP,
    FLIP_ORDER_NOLOOP,
    FLIP_REVERSE_NOLOOP,
    FLIP_CUSTOMIZED_LOOP,    //!< TODO:
    FLIP_CUSTOMIZED_NOLOOP,  //!< TODO:
    NOT_ANIMATED
};

enum GgafDxPuppeteerMethod {
    NO_CHENGE = 0,
    PLAY_LOOPING = 1,
    PLAY_OSCILLATING = 2
};

enum GgafDxPuppeteerStick {
    LEFT_HAND  = 0,
    RIGHT_HAND = 1
};


enum GgafDxAlign {
    ALIGN_LEFT,
    ALIGN_CENTER,
    ALIGN_RIGHT,
};
enum GgafDxValign {
    VALIGN_TOP,
    VALIGN_MIDDLE,
    VALIGN_BOTTOM,
};


#define Obj_GgafDxScene        ((0x10ULL) | Obj_SceneBit)  //0b 10000000 00000000 00000000 00000000 00000000 00000000 00000000 00010000
#define Obj_GgafDxSpacetime    ((0x20ULL) | Obj_SceneBit)  //0b 10000000 00000000 00000000 00000000 00000000 00000000 00000000 00100000

#define Obj_GgafDxBaseActor                    (0x100ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00000000 00000001 00000000
#define Obj_GgafDxGeometricActor               (0x200ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00000000 00000010 00000000
#define Obj_GgafDxFigureActor                  (0x400ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00000000 00000100 00000000
#define Obj_GgafDxMeshActor                    (0x800ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00000000 00001000 00000000
#define Obj_GgafDxMeshSetActor                (0x1000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00000000 00010000 00000000
#define Obj_GgafDxMorphMeshActor              (0x2000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00000000 00100000 00000000
#define Obj_GgafDxD3DXMeshActor               (0x4000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00000000 01000000 00000000
#define Obj_GgafDxDynaD3DXMeshActor           (0x8000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00000000 10000000 00000000
#define Obj_GgafDxD3DXAniMeshActor           (0x10000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00000001 00000000 00000000
#define Obj_GgafDxSpriteMeshActor            (0x20000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00000010 00000000 00000000
#define Obj_GgafDxSpriteMeshSetActor         (0x40000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00000100 00000000 00000000
#define Obj_GgafDxCubeMapMeshActor           (0x80000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00001000 00000000 00000000
#define Obj_GgafDxCubeMapMeshSetActor       (0x100000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00010000 00000000 00000000
#define Obj_GgafDxCubeMapMorphMeshActor     (0x200000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 00100000 00000000 00000000
#define Obj_GgafDxWorldBoundActor           (0x400000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 01000000 00000000 00000000
#define Obj_GgafDxSpriteActor               (0x800000ULL)  //0b 00000000 00000000 00000000 00000000 00000000 10000000 00000000 00000000
#define Obj_GgafDxSpriteSetActor           (0x1000000ULL)  //0b 00000000 00000000 00000000 00000000 00000001 00000000 00000000 00000000
#define Obj_GgafDxBoardActor               (0x2000000ULL)  //0b 00000000 00000000 00000000 00000000 00000010 00000000 00000000 00000000
#define Obj_GgafDxBoardSetActor            (0x4000000ULL)  //0b 00000000 00000000 00000000 00000000 00000100 00000000 00000000 00000000
#define Obj_GgafDxPointSpriteActor         (0x8000000ULL)  //0b 00000000 00000000 00000000 00000000 00001000 00000000 00000000 00000000
#define Obj_GgafDxMassActor               (0x10000000ULL)  //0b 00000000 00000000 00000000 00000000 00010000 00000000 00000000 00000000
#define Obj_GgafDxMassMeshActor           (0x20000000ULL)  //0b 00000000 00000000 00000000 00000000 00100000 00000000 00000000 00000000
#define Obj_GgafDxMassBoardActor          (0x40000000ULL)  //0b 00000000 00000000 00000000 00000000 01000000 00000000 00000000 00000000
#define Obj_GgafDxMassSpriteActor         (0x80000000ULL)  //0b 00000000 00000000 00000000 00000000 10000000 00000000 00000000 00000000
#define Obj_GgafDxMassMorphMeshActor     (0x100000000ULL)  //0b 00000000 00000000 00000000 00000001 00000000 00000000 00000000 00000000
#define Obj_GgafDxMassPointSpriteActor   (0x200000000ULL)  //0b 00000000 00000000 00000000 00000010 00000000 00000000 00000000 00000000
#define Obj_GgafDxPointSpriteSetActor    (0x400000000ULL)  //0b 00000000 00000000 00000000 00000100 00000000 00000000 00000000 00000000


//O錾(forward declaration)
namespace IkdLib {
//u~i܂؂j[ǂƃRv http://marupeke296.com/index.html
// ̎AIkd oggt@CĐCu
class PCMPlayer;
class OggVorbisResource;
class PCMDecoder;
class OggDecoder;
class OggVorbisFile;
class OggVorbisMemory;
}
//O錾(forward declaration)
namespace Frm {
class Model3D;
class Mesh;
}

//O錾(forward declaration)
namespace GgafDxCore {

class GgafDxCriticalException;
class GgafDxProperties;
class GgafDxGod;
class GgafDxInput;
class GgafDxSound;

class GgafDxTextureConnection;
class GgafDxTextureManager;
class GgafDxModelConnection;
class GgafDxModelManager;
class GgafDxEffectConnection;
class GgafDxEffectManager;

class GgafDxAllocHierarchy;
class D3DXFRAME_WORLD;
class GgafDxAllocHierarchyWorldFrame;
class GgafDxWorldMatStack;

class GgafDxICubeMapActor;
class GgafDxIBumpMapActor;

class GgafDxBaseActor;
class GgafDxGeometricActor;
class GgafDxFigureActor;
class GgafDxMassActor;
class GgafDxMeshActor;
class GgafDxMeshSetActor;
class GgafDxMassMeshActor;
class GgafDxMorphMeshActor;
class GgafDxMassMorphMeshActor;
class GgafDxD3DXMeshActor;
class GgafDxDynaD3DXMeshActor;
class GgafDxD3DXAniMeshActor;
class GgafDxSpriteMeshActor;
class GgafDxSpriteMeshSetActor;
class GgafDxCubeMapMeshActor;
class GgafDxCubeMapMeshSetActor;
class GgafDxCubeMapMorphMeshActor;
class GgafDxWorldBoundActor;
class GgafDxAABActor;
class GgafDxAAPrismActor;
class GgafDxAAPyramidActor;
class GgafDxSphereActor;
class GgafDxSpriteActor;
class GgafDxSpriteSetActor;
class GgafDxMassSpriteActor;
class GgafDxCamera;
class GgafDxCameraViewPoint;
class GgafDxCameraUpVector;
class GgafDxBoardActor;
class GgafDxBoardSetActor;
class GgafDxMassBoardActor;
class GgafDxPointSpriteActor;
class GgafDxMassPointSpriteActor;
class GgafDxPointSpriteSetActor;

class GgafDxModel;
class GgafDxMassModel;
class GgafDxD3DXMeshModel;
class GgafDxD3DXAniMeshModel;
class GgafDxSpriteModel;
class GgafDxSpriteSetModel;
class GgafDxMassSpriteModel;
class GgafDxMeshModel;
class GgafDxMeshSetModel;
class GgafDxMassMeshModel;
class GgafDxMorphMeshModel;
class GgafDxMassMorphMeshModel;
class GgafDxCubeMapMeshModel;
class GgafDxCubeMapMeshSetModel;
class GgafDxCubeMapMorphMeshModel;
class GgafDxWorldBoundModel;
class GgafDxBoardModel;
class GgafDxBoardSetModel;
class GgafDxMassBoardModel;
class GgafDxPointSpriteModel;
class GgafDxMassPointSpriteModel;
class GgafDxPointSpriteSetModel;

class GgafDxEffect;
class GgafDxMassEffect;
class GgafDxMeshEffect;
class GgafDxD3DXAniMeshEffect;
class GgafDxMeshSetEffect;
class GgafDxMassMeshEffect;
class GgafDxMorphMeshEffect;
class GgafDxMassMorphMeshEffect;
class GgafDxCubeMapMeshEffect;
class GgafDxCubeMapMeshSetEffect;
class GgafDxCubeMapMorphMeshEffect;
class GgafDxWorldBoundEffect;
class GgafDxSpriteEffect;
class GgafDxSpriteSetEffect;
class GgafDxMassSpriteEffect;
class GgafDxBoardEffect;
class GgafDxBoardSetEffect;
class GgafDxMassBoardEffect;
class GgafDxPointSpriteEffect;
class GgafDxMassPointSpriteEffect;
class GgafDxPointSpriteSetEffect;

class GgafDxTexture;

class GgafDxScene;
class GgafDxSpacetime;

class GgafDxUtil;
class GgafDx26DirectionUtil;

class GgafDxSphereRadiusVectors;
class GgafDxQuaternion;
class GgafDxCollisionArea;
class GgafDxCollisionPart;
class GgafDxGeoElem;
class GgafDxKuroko;
class GgafDxKurokoMvAssistant;
class GgafDxKurokoFaceAngAssistant;
class GgafDxKurokoMvAngAssistant;
class GgafDxAxesMover;
class GgafDxAxesMoverAssistantA;
class GgafDxChecker;
class GgafDxScaler;
class GgafDxAlphaFader;
class GgafDxColorist;
class GgafDxSeTransmitter;
class GgafDxSeTransmitterForActor;
class GgafDxBgmPerformer;
class GgafDxAlphaCurtain;
class GgafDxBgmPerformerForScene;
class GgafDxTextureBlinker;
class GgafDxUvFlipper;
class GgafDxPuppeteer;

class GgafDxSe;
class GgafDxBgm;
class GgafDxSeConnection;
class GgafDxSeManager;
class GgafDxBgmConnection;
class GgafDxBgmManager;
class GgafDxSound;
class CWaveDecorder;

}

#endif /*GGAFDXCOMMONHEADER_H_*/
