#ifndef GGAFDXCORE_GGAFDXMASSBOARDACTOR_H_
#define GGAFDXCORE_GGAFDXMASSBOARDACTOR_H_
#include "GgafDxCommonHeader.h"
#include "jp/ggaf/dxcore/actor/GgafDxMassActor.h"
#include "jp/ggaf/dxcore/model/GgafDxMassBoardModel.h"

namespace GgafDxCore {

/**
 * Wϊς݂̃XvCgAN^[(ʕ\p) .
 * GgafDxTransformedActor pA|SɃeNX`\t<BR>
 * GgafDxBoardActorɁAꃂf͈ꊇ`s悤ɍœKAN^[B<BR>
 * ]@\ȂAgk@\ȂB<BR>
 * P\̂ߍB\AwiɎgpB<BR>
 * @version 1.00
 * @since 2016/02/25
 * @author Masatoshi Tsuge
 */
class GgafDxMassBoardActor : public GgafDxMassActor {
private:
    /**
     * gps̂߁Aprivateoverride
     * @return
     */
    int isOutOfView() override {
        throwGgafCriticalException("gpsłB");
        return 0;
    }

    /**
     * gps̂߁Aprivateoverride
     * @return
     */
    bool isOutOfSpacetime() const override {
        throwGgafCriticalException("gpsłB");
        return false;
    }

    /**
     * gps̂߁Aprivateoverride
     * @return
     */
    GgafCore::GgafGroupHead* addSubGroupAsFk(actorkind prm_kind,
                                             GgafDxGeometricActor* prm_pGeoActor,
                                             int prm_x_init_local,
                                             int prm_y_init_local,
                                             int prm_z_init_local,
                                             int prm_rx_init_local,
                                             int prm_ry_init_local,
                                             int prm_rz_init_local) override {
        throwGgafCriticalException("gpsłB");
        return nullptr;
    }

    /**
     * gps̂߁Aprivateoverride
     * @return
     */
    GgafCore::GgafGroupHead* addSubGroupAsFk(GgafDxGeometricActor* prm_pGeoActor,
                                             int prm_x_init_local,
                                             int prm_y_init_local,
                                             int prm_z_init_local,
                                             int prm_rx_init_local,
                                             int prm_ry_init_local,
                                             int prm_rz_init_local) override {
        throwGgafCriticalException("gpsłB");
        return nullptr;
    }
public:
    /** [r]fIuWFNgւ̃|C^ */
    GgafDxMassBoardModel* const _pMassBoardModel;
    /** [r]GtFNg */
    GgafDxMassBoardEffect* const _pMassBoardEffect;
    /** [r]UVtbp[(ppAj) */
    GgafDxUvFlipper* const _pUvFlipper;

    GgafDxAlign _align;
    GgafDxValign _valign;

public:
    GgafDxMassBoardActor(const char* prm_name,
                         const char* prm_model_id,
                         const char* prm_effect_id,
                         const char* prm_technique );

    virtual void processSettlementBehavior() override {
    }

    virtual void positionAs(const GgafDxGeometricActor* prm_pActor) override;

    virtual void positionAs(const GgafDxGeoElem* prm_pGeoElem) override;

    virtual void setAlign(GgafDxAlign prm_align, GgafDxValign prm_valign);
    virtual void setAlign(GgafDxAlign prm_align);
    virtual void setValign(GgafDxValign prm_valign);
    virtual void setScale(scale s) override;
    virtual void setScale(scale sx, scale sy) override;
    virtual void setScale(scale sx, scale sy, scale sz) override;
    virtual void setScaleR(float prm_rate) override;
    virtual void setScaleR(float prm_x_rate, float prm_y_rate) override;
    virtual void setScaleR(float prm_x_rate, float prm_y_rate, float prm_z_rate) override;
    virtual void addScaleX(scale dsx) override {
        _sx += dsx;
    }
    virtual void addScaleY(scale dsy) override {
        _sy += dsy;
    }
    virtual void addScaleZ(scale dsz) override {
        _sz += dsz;
    }


    inline GgafDxUvFlipper* getUvFlipper() {
        return _pUvFlipper;
    }
    float getModelWidth();
    float getModelHeight();

    virtual ~GgafDxMassBoardActor(); //fXgN^
};

}
#endif /*GGAFDXCORE_GGAFDXMASSBOARDACTOR_H_*/
