#ifndef GGAFDXCORE_GGAFDXCHECKER_H_
#define GGAFDXCORE_GGAFDXCHECKER_H_
#include "GgafDxCommonHeader.h"
#include "jp/ggaf/core/GgafObject.h"

namespace GgafDxCore {

/**
 * `FbNɊւFXȋ@\NX .
 * iGgafDxGeometryCheckerj
 * @version 1.00
 * @since 2008/08/20
 * @author Masatoshi Tsuge
 */
class GgafDxChecker : public GgafCore::GgafObject {

public:
    /** ΏۃAN^[ */
    GgafDxGeometricActor* const _pActor;
    /** 蔻̈ */
    GgafDxCollisionArea* _pCollisionArea;

public:
    /**
     * RXgN^<BR>
     * @param	prm_pActor	KpActor
     */
    explicit GgafDxChecker(GgafDxGeometricActor* prm_pActor);

    virtual void updateHitArea() = 0;

    /**
     * 蔻̈쐬i蔻̈vf̔z쐬j .
     * ŗ̈̔z𐶐܂B
     * ŏɕKsĂB
     * @param prm_colli_part_num 蔻̈̓蔻̈vf(1`n)
     */
    virtual void createCollisionArea(int prm_colli_part_num);

    /**
     * qbgVĂ邩ǂ
     * @param prm_pOtherChecker ̃`FbJ[
     * @return
     */
    virtual bool isHit(const GgafDxChecker* const prm_pOtherChecker) = 0;

    virtual GgafDxGeometricActor* getTargetActor() {
        if (_pActor == nullptr) {
            _TRACE_(FUNC_NAME<<" nullptrł邪悢̂I");
        }
        return _pActor;
    }

    inline GgafDxCollisionArea* getArea() {
        return _pCollisionArea;
    }

    /**
     * 蔻̗̈vfLɂB
     * ftHg͗LԂɂȂĂ܂B
     * @param prm_index Lɂ铖蔻̗̈vfԍ
     */
    virtual void enable(int prm_index);

    /**
     * 蔻̗̈vf𖳌ɂB
     * @param prm_index ɂ铖蔻̗̈vfԍ
     */
    virtual void disable(int prm_index);

    /**
     * 蔻̗̈vfLׂB
     * @param prm_index ׂ蔻̗̈vfԍ
     * @return true:L / false:
     */
    virtual bool isEnable(int prm_index);

    virtual ~GgafDxChecker();
};

}
#endif /*GGAFDXCORE_GGAFDXCHECKER_H_*/

