#ifndef GGAFDXCORE_GGAFDXEFFECTMANAGER_H_
#define GGAFDXCORE_GGAFDXEFFECTMANAGER_H_
#include "GgafDxCommonHeader.h"
#include "jp/ggaf/core/util/GgafResourceManager.hpp"

#include "jp/ggaf/dxcore/effect/GgafDxEffect.h"


namespace GgafDxCore {

/**
 * GgafDxEffectConnection ǗNX .
 * ς GgafDxEffectConnection IuWFNgo^ĂAg܂킵܂B
 * @version 1.00
 * @since 2009/02/09
 * @author Masatoshi Tsuge
 */
class GgafDxEffectManager : public GgafCore::GgafResourceManager<GgafDxEffect> {

public:
    static GgafDxEffect* _pEffect_active;

public:
    /**
     * RXgN^
     * @param prm_manager_name }l[W(eK{)
     */
    GgafDxEffectManager(const char* prm_manager_name);

    /**
     * GtFNgIDɂAGtFNguWFNg𐶐 .
     * <pre>
     * prm_idstř`
     * prm_idstŕA
     * wGtFNg^Cv  + "/" + fxt@C(gq .fx )x
     * ƂɂȂĂBGtFNg^Cv͈ȉ̒ʂ
     * 'D': GgafDxMeshEffect IuWFNg
     * 'd': GgafDxMeshEffect IuWFNg
     * 'X': GgafDxMeshEffect IuWFNg
     * 'x': GgafDxMeshSetEffect IuWFNg
     * 't': GgafDxMassMeshEffect IuWFNg
     * 'A': GgafDxD3DXAniMeshEffect IuWFNg
     * 'M': GgafDxMorphMeshEffect IuWFNg
     * 'S': GgafDxSpriteEffect IuWFNg
     * 's': GgafDxSpriteSetEffect IuWFNg
     * 'B': GgafDxBoardEffect IuWFNg
     * 'b': GgafDxBoardSetEffect IuWFNg
     *
     * F"x/LaserChipEffect" ̏ꍇB
     * "LaserChipEffect.fx"ǂݍ GgafDxMeshSetEffectCX^X ԂB
     * </pre>
     * @param prm_idstr GtFNgID
     * @param prm_p Rp[^Aݖgp
     * @return GtFNgIuWFNg
     */
    GgafDxEffect* processCreateResource(const char* prm_idstr, void* prm_pConnector) override;

    GgafCore::GgafResourceConnection<GgafDxEffect>* processCreateConnection(const char* prm_idstr, GgafDxEffect* prm_pResource) override;

    void setParamPerFrameAll();

    void restoreAll();

    void onDeviceLostAll();

    virtual ~GgafDxEffectManager() {
    }
};

}
#endif /*GGAFDXCORE_GGAFDXEFFECTMANAGER_H_*/
