#ifndef GGAFLIB_DEFAULTMASSMORPHMESHACTOR_H_
#define GGAFLIB_DEFAULTMASSMORPHMESHACTOR_H_
#include "GgafLibCommonHeader.h"
#include "jp/ggaf/dxcore/actor/GgafDxMassMorphMeshActor.h"

namespace GgafLib {

/**
 * [tbVAN^[̋ۃNX.
 * GgafDxCore::GgafDxMassMorphMeshActor ۃAN^[łB
 * {NXpăLN^[쐬܂傤B<BR>
 * ȉɎgp\ȎxIuWFNgLB<BR>
 * <TABLE border=1>
 * <TR bgcolor="#AABBCC"><TH>IuWFNgւ̃ANZX</TH><TH>Tv</TH><TH>CLASS</TH></TR>
 * <TR><TD>getProgress()</TD><TD>iǗ</TD><TD>GgafCore::GgafProgress</TD></TR>
 * <TR><TD>getKuroko()</TD><TD>߁Bړ]x</TD><TD>GgafDxCore::GgafDxKuroko</TD></TR>
 * <TR><TD>getSeTx()</TD><TD>ʉǗ</TD><TD>GgafDxCore::GgafDxSeTransmitter</TD></TR>
 * <TR><TD>getMorpher()</TD><TD>[tBOx</TD><TD>GgafDxCore::GgafDxMorpher</TD></TR>
 * <TR><TD>getCollisionChecker()</TD><TD>Փ˔x</TD><TD>GgafLib::CollisionChecker3D</TD></TR>
 * </TABLE>
 * @version 1.00
 * @since 2009/05/08
 * @author Masatoshi Tsuge
 */
class DefaultMassMorphMeshActor : public GgafDxCore::GgafDxMassMorphMeshActor {

    struct VERTEX_instancedata {
        float _11, _12, _13, _14;   // : TEXCOORD1  WorldϊsAPs
        float _21, _22, _23, _24;   // : TEXCOORD2  WorldϊsAQs
        float _31, _32, _33, _34;   // : TEXCOORD3  WorldϊsARs
        float _41, _42, _43, _44;   // : TEXCOORD4  WorldϊsASs
        float r, g, b, a;           // : TEXCOORD5  }eAJ[
        //_14 : [t^[Qbg1̏d݂̒lߍ܂BVF[_[Ŏo0ɏ㏑B
        //_24 : [t^[Qbg2̏d݂̒lߍ܂BVF[_[Ŏo0ɏ㏑B
        //_34 : [t^[Qbg3̏d݂̒lߍ܂BVF[_[Ŏo0ɏ㏑B
        //_44 : [t^[Qbg4̏d݂̒lߍ܂BVF[_[Ŏo1ɏ㏑B
    };

    static VERTEX_instancedata _aInstancedata[];
    static void createVertexInstaceData(void* prm, GgafDxCore::GgafDxMassModel::VertexInstaceDataInfo* out_info);

public:
    /** Փ˔xIuWFNg */
    CollisionChecker3D* _pColliChecker;

public:
    DefaultMassMorphMeshActor(const char* prm_name, const char* prm_model_id, GgafCore::GgafStatus* prm_pStat=nullptr);

    virtual void onCreateModel() override {
    }

    virtual void initialize() override {
    }

    virtual void processBehavior() override {
    }

    virtual void processJudgement() override {
    }

    virtual void processDraw() override;

    virtual void onCatchEvent(hashval prm_no, void* prm_pSource) override {
    }

    virtual void onHit(const GgafCore::GgafActor* prm_pOtherActor) override {
    }

    virtual void drawHitArea() override;

    inline CollisionChecker3D* getCollisionChecker() {
        return _pColliChecker;
    }

    virtual ~DefaultMassMorphMeshActor();
};

}
#endif /*GGAFLIB_DEFAULTMASSMORPHMESHACTOR_H_*/
