#ifndef GGAFLIB_DEFAULTMASSSPRITEACTOR_H_
#define GGAFLIB_DEFAULTMASSSPRITEACTOR_H_
#include "GgafLibCommonHeader.h"
#include "jp/ggaf/dxcore/actor/GgafDxMassSpriteActor.h"

namespace GgafLib {

/**
 * XvCgZbgAN^[̋ۃNX.
 * GgafDxCore::GgafDxMassSpriteActor ۃAN^[łB
 * {NXpăLN^[쐬܂傤B<BR>
 * ȉɎgp\ȎxIuWFNgLB<BR>
 * <TABLE border=1>
 * <TR bgcolor="#AABBCC"><TH>IuWFNgւ̃ANZX</TH><TH>Tv</TH><TH>CLASS</TH></TR>
 * <TR><TD>getProgress()</TD><TD>iǗ</TD><TD>GgafCore::GgafProgress</TD></TR>
 * <TR><TD>getKuroko()</TD><TD>߁Bړ]x</TD><TD>GgafDxCore::GgafDxKuroko</TD></TR>
 * <TR><TD>getUvFlipper()</TD><TD>ppAj[Vx</TD><TD>GgafDxCore::GgafDxUvFlipper</TD></TR>
 * <TR><TD>getSeTx()</TD><TD>ʉǗ</TD><TD>GgafDxCore::GgafDxSeTransmitter</TD></TR>
 * <TR><TD>getCollisionChecker()</TD><TD>Փ˔x</TD><TD>GgafLib::CollisionChecker3D</TD></TR>
 * </TABLE>
 * @version 1.00
 * @since 2016/02/25
 * @author Masatoshi Tsuge
 */
class DefaultMassSpriteActor : public GgafDxCore::GgafDxMassSpriteActor {

private:
    struct VERTEX_instancedata {
        float _11, _12, _13, _14;   // : TEXCOORD1  WorldϊsAPs
        float _21, _22, _23, _24;   // : TEXCOORD2  WorldϊsAQs
        float _31, _32, _33, _34;   // : TEXCOORD3  WorldϊsARs
        float _41, _42, _43, _44;   // : TEXCOORD4  WorldϊsASs
        float local_x, local_y;     // : TEXCOORD5  [JWItZbg
        float offset_u, offset_v;   // : TEXCOORD6  eNX`ItZbg
        float r, g, b, a;           // : TEXCOORD7  }eAJ[
    };
    static VERTEX_instancedata _aInstancedata[];
    static void createVertexInstaceData(void* prm, GgafDxCore::GgafDxMassModel::VertexInstaceDataInfo* out_info);
public:
    /** Փ˔xIuWFNg */
    CollisionChecker3D* _pColliChecker;

    DefaultMassSpriteActor(const char* prm_name, const char* prm_model_id, GgafCore::GgafStatus* prm_pStat=nullptr);

    virtual void onCreateModel() override {
    }

    virtual void initialize() override {
    }

    virtual void processBehavior() override {
    }

    virtual void processJudgement() override {
    }

    virtual void processDraw() override;

    virtual void onCatchEvent(hashval prm_no, void* prm_pSource) override {
    }

    virtual void onHit(const GgafCore::GgafActor* prm_pOtherActor) override {
    }

    virtual void drawHitArea() override;

    inline CollisionChecker3D* getCollisionChecker() {
        return _pColliChecker;
    }

    virtual ~DefaultMassSpriteActor();

};

}
#endif /*GGAFLIB_DEFAULTMASSSPRITEACTOR_H_*/
