#include "SmpWorld.h"

#include "jp/ggaf/core/actor/GgafSceneDirector.h"
#include "actor/SmpActor.h"

using namespace SimpleSample;

SmpWorld::SmpWorld(const char* prm_name) : GgafLib::DefaultScene(prm_name) {
    pActor_ = new SmpActor("TEST");  //LN^[쐬ێ
    bringDirector()->addSubGroup(pActor_);  //LN^[V[ē̔zɏi\j
    vb_.remap(VB_UP     , VBK_UP   , VBJ_Y_POS_MINUS);  //VB_UP      = L[{[h ܂́AY| ƂB
    vb_.remap(VB_DOWN   , VBK_DOWN , VBJ_Y_POS_PLUS );  //VB_DOWN    = L[{[h ܂́AY{ ƂB
    vb_.remap(VB_LEFT   , VBK_LEFT , VBJ_X_POS_MINUS);  //VB_LEFT    = L[{[h ܂́AX| ƂB
    vb_.remap(VB_RIGHT  , VBK_RIGHT, VBJ_X_POS_PLUS );  //VB_RIGHT   = L[{[h ܂́AX{ ƂB
    vb_.remap(VB_BUTTON1, VBK_SPACE, VBJ_BUTTON_01  );  //VB_BUTTON1 = Xy[XL[ ܂ WCXeBbN{^P ƂB
}

void SmpWorld::initialize() {
}

void SmpWorld::processBehavior() {
    //L{^͂ňړ
    vb_.update(); //͏󋵍XV
    if (vb_.isBeingPressed(VB_BUTTON1)) {
        //{^PiXy[XL[jȂ̏ꍇ
        if (vb_.isBeingPressed(VB_UP)) {
            pActor_->_z += PX_C(2); //
        }
        if (vb_.isBeingPressed(VB_DOWN)) {
            pActor_->_z -= PX_C(2); //O
        }
    } else {
        //{^PiXy[XL[j𗣂Ăꍇ
        if (vb_.isBeingPressed(VB_RIGHT)) {
            pActor_->_x += PX_C(2); //E
        }
        if (vb_.isBeingPressed(VB_LEFT)) {
            pActor_->_x -= PX_C(2); //
        }
        if (vb_.isBeingPressed(VB_UP)) {
            pActor_->_y += PX_C(2); //
        }
        if (vb_.isBeingPressed(VB_DOWN)) {
            pActor_->_y -= PX_C(2); //
        }
    }
}

SmpWorld::~SmpWorld() {
}
